// XColourPickerTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "XColourPickerTest.h"
#include "XColourPickerTestDlg.h"
#include "about.h"
#include "FontSize.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CXColourPickerTestDlg dialog

BEGIN_MESSAGE_MAP(CXColourPickerTestDlg, CDialog)
	//{{AFX_MSG_MAP(CXColourPickerTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(CPN_SELCHANGE, OnColourChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CXColourPickerTestDlg::CXColourPickerTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXColourPickerTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXColourPickerTestDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_rgbText = RGB(0,0,0);
	m_rgbBackground = RGB(255, 153, 0);
	m_strTextCustomColours = _T("");
	m_strBackgroundCustomColours = _T("");
}

CXColourPickerTestDlg::~CXColourPickerTestDlg()
{
	if (m_font.GetSafeHandle())
		m_font.DeleteObject();
}

void CXColourPickerTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXColourPickerTestDlg)
	DDX_Control(pDX, IDC_COLOUR_SAMPLE, m_stcColourSample);
	DDX_Control(pDX, IDC_BACKGROUND_COLOUR, m_ctlBackgroundColour);
	DDX_Control(pDX, IDC_TEXT_COLOUR, m_ctlTextColour);
	//}}AFX_DATA_MAP

	DDX_ColorPicker(pDX, IDC_TEXT_COLOUR, m_rgbText);
	DDX_ColorPicker(pDX, IDC_BACKGROUND_COLOUR, m_rgbBackground);

	DDX_ColorPickerCustom(pDX, IDC_TEXT_COLOUR, m_strTextCustomColours);
	DDX_ColorPickerCustom(pDX, IDC_BACKGROUND_COLOUR, m_strBackgroundCustomColours);

	if (pDX->m_bSaveAndValidate)
	{
		TRACE("   moving data to data members\n");
		if (m_rgbText == m_rgbBackground)
		{
			::MessageBox(m_hWnd,
						"The text and background colours are identical.\r\n"
						"The text will not be readable.",
						"Unreadable Colours",
						MB_ICONEXCLAMATION);
			pDX->Fail();
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CXColourPickerTestDlg message handlers

BOOL CXColourPickerTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	LOGFONT lf;

	memset(&lf, 0, sizeof(lf));
	lf.lfWeight = 400;
	lf.lfHeight = GetFontHeight(14);
	_tcscpy(lf.lfFaceName, _T("Arial"));
	m_font.CreateFontIndirect(&lf);
	m_stcColourSample.SetFont(&m_font);

	m_stcColourSample.SetWindowText(_T("Sample text"));
	m_stcColourSample.SetTextColor(m_rgbText);
	m_stcColourSample.SetBackgroundColor(m_rgbBackground);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CXColourPickerTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CXColourPickerTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CXColourPickerTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CXColourPickerTestDlg::OnColourChange(WPARAM, LPARAM lParam)
{
	TRACE(_T("in CXColourPickerTestDlg::OnColourChange\n"));

	if (lParam == IDC_TEXT_COLOUR)
	{
		TRACE("IDC_TEXT_COLOUR\n");
	}
	else if (lParam == IDC_BACKGROUND_COLOUR)
	{
		TRACE("IDC_BACKGROUND_COLOUR\n");
	}

	if (m_ctlTextColour.GetColor() == m_ctlBackgroundColour.GetColor())
	{
		::MessageBox(m_hWnd,
					"The text and background colours are identical.\r\n"
					"The text will not be readable.",
					"Unreadable Colours",
					MB_ICONEXCLAMATION);
	}
	else
	{
		m_rgbText = m_ctlTextColour.GetColor();
		m_rgbBackground = m_ctlBackgroundColour.GetColor();
	}

	m_ctlTextColour.SetColor(m_rgbText);
	m_ctlBackgroundColour.SetColor(m_rgbBackground);
	m_stcColourSample.SetTextColor(m_rgbText);
	m_stcColourSample.SetBackgroundColor(m_rgbBackground);

	return 0;
}
